package com.richmayfield.isatest;

import ioio.lib.api.AnalogInput;
import ioio.lib.api.DigitalOutput;
import ioio.lib.api.exception.ConnectionLostException;
import ioio.lib.util.BaseIOIOLooper;
import ioio.lib.util.IOIOLooper;
import ioio.lib.util.android.IOIOActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.ToggleButton;

public class TestScreen extends IOIOActivity {
	private ToggleButton button0;
	private ToggleButton button1;
	private ToggleButton button2;
	private ToggleButton button3;
	private ToggleButton button4;
	private ToggleButton button5;
	private ToggleButton button6;
	private ToggleButton button7;
	private ToggleButton button8;
	private ToggleButton button9;
	private ToggleButton button10;
	private ToggleButton button11;
	private ToggleButton button12;
	private ToggleButton button13;
	private ToggleButton buttonAll;

	
	private float V0= 0;
	private float V1= 0;
	private float V2= 0;
	private float V3= 0;
	private float V4= 0;
	private float V5= 0;
	private double V_in= 0;
	private double VinScale= 4.64;
	
	private TextView textViewA0;
	private TextView textViewA1;
	private TextView textViewA2;
	private TextView textViewA3;
	private TextView textViewA4;
	private TextView textViewA5;
	private TextView textViewVin;
	
	public void updateText(){
		runOnUiThread(new Runnable() {
			@Override
			public void run() {
				textViewA0.setText(V0 +" V");
				textViewA1.setText(V1 +" V");
				textViewA2.setText(V2 +" V");
				textViewA3.setText(V3 +" V");
				textViewA4.setText(V4 +" V");
				textViewA5.setText(V5 +" V");
				textViewVin.setText(V_in +" V");
			}
		});

	}

	/**
	 * Called when the activity is first created. Here we normally initialize
	 * our GUI.
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_test_screen);
		button0 = (ToggleButton) findViewById(R.id.toggleButton0);
		button1 = (ToggleButton) findViewById(R.id.toggleButton1);
		button2 = (ToggleButton) findViewById(R.id.toggleButton2);
		button3 = (ToggleButton) findViewById(R.id.toggleButton3);
		button4 = (ToggleButton) findViewById(R.id.toggleButton4);
		button5 = (ToggleButton) findViewById(R.id.toggleButton5);
		button6 = (ToggleButton) findViewById(R.id.toggleButton6);
		button7 = (ToggleButton) findViewById(R.id.toggleButton7);
		button8 = (ToggleButton) findViewById(R.id.toggleButton8);
		button9 = (ToggleButton) findViewById(R.id.toggleButton9);
		button10 = (ToggleButton) findViewById(R.id.toggleButton10);
		button11 = (ToggleButton) findViewById(R.id.toggleButton11);
		button12 = (ToggleButton) findViewById(R.id.toggleButton12);
		button13 = (ToggleButton) findViewById(R.id.toggleButton13);
		buttonAll = (ToggleButton) findViewById(R.id.toggleButtonAll);
		
		textViewA0 = (TextView) findViewById(R.id.textViewA0);
		textViewA1 = (TextView) findViewById(R.id.textViewA1);
		textViewA2 = (TextView) findViewById(R.id.textViewA2);
		textViewA3 = (TextView) findViewById(R.id.textViewA3);
		textViewA4 = (TextView) findViewById(R.id.textViewA4);
		textViewA5 = (TextView) findViewById(R.id.textViewA5);
		textViewVin = (TextView) findViewById(R.id.textViewVin);
		
	}

	/**
	 * This is the thread on which all the IOIO activity happens. It will be run
	 * every time the application is resumed and aborted when it is paused. The
	 * method setup() will be called right after a connection with the IOIO has
	 * been established (which might happen several times!). Then, loop() will
	 * be called repetitively until the IOIO gets disconnected.
	 */
	class Looper extends BaseIOIOLooper {
		/** Digital Outputs */
		private DigitalOutput OnboardLED;
		private DigitalOutput Arduino0;
		private DigitalOutput Arduino1;
		private DigitalOutput Arduino2;
		private DigitalOutput Arduino3;
		private DigitalOutput Arduino4;
		private DigitalOutput Arduino5;
		private DigitalOutput Arduino6;
		private DigitalOutput Arduino7;
		private DigitalOutput Arduino8;
		private DigitalOutput Arduino9;
		private DigitalOutput Arduino10;
		private DigitalOutput Arduino11;
		private DigitalOutput Arduino12;
		private DigitalOutput Arduino13;
		
		private AnalogInput A0;
		private AnalogInput A1;
		private AnalogInput A2;
		private AnalogInput A3;
		private AnalogInput A4;
		private AnalogInput A5;
		private AnalogInput Vin;
		

		



		/**
		 * Called every time a connection with IOIO has been established.
		 * Typically used to open pins.
		 * 
		 * @throws ConnectionLostException
		 *             When IOIO connection is lost.
		 * 
		 * @see ioio.lib.util.AbstractIOIOActivity.IOIOThread#setup()
		 */
		@Override
		protected void setup() throws ConnectionLostException {
			OnboardLED = ioio_.openDigitalOutput(0, true);
			Arduino0 = ioio_.openDigitalOutput(ISA.ARDUINO_0, true);
			Arduino1 = ioio_.openDigitalOutput(ISA.ARDUINO_1, true);
			Arduino2 = ioio_.openDigitalOutput(ISA.ARDUINO_2, true);
			Arduino3 = ioio_.openDigitalOutput(ISA.ARDUINO_3, true);
			Arduino4 = ioio_.openDigitalOutput(ISA.ARDUINO_4, true);
			Arduino5 = ioio_.openDigitalOutput(ISA.ARDUINO_5, true);
			Arduino6 = ioio_.openDigitalOutput(ISA.ARDUINO_6, true);
			Arduino7 = ioio_.openDigitalOutput(ISA.ARDUINO_7, true);
			Arduino8 = ioio_.openDigitalOutput(ISA.ARDUINO_8, true);
			Arduino9 = ioio_.openDigitalOutput(ISA.ARDUINO_9, true);
			Arduino10 = ioio_.openDigitalOutput(ISA.ARDUINO_10, true);
			Arduino11 = ioio_.openDigitalOutput(ISA.ARDUINO_11, true);
			Arduino12 = ioio_.openDigitalOutput(ISA.ARDUINO_12, true);
			Arduino13 = ioio_.openDigitalOutput(ISA.ARDUINO_13, true);
			
			A0 = ioio_.openAnalogInput(ISA.ARDUINO_AD0);
			A1 = ioio_.openAnalogInput(ISA.ARDUINO_AD1);
			A2 = ioio_.openAnalogInput(ISA.ARDUINO_AD2);
			A3 = ioio_.openAnalogInput(ISA.ARDUINO_AD3);
			A4 = ioio_.openAnalogInput(ISA.ARDUINO_AD4);
			A5 = ioio_.openAnalogInput(ISA.ARDUINO_AD5);
			Vin = ioio_.openAnalogInput(39);
			
			
		}

		/**
		 * Called repetitively while the IOIO is connected.
		 * 
		 * @throws ConnectionLostException
		 *             When IOIO connection is lost.
		 * 
		 * @see ioio.lib.util.AbstractIOIOActivity.IOIOThread#loop()
		 */
		@Override
		public void loop() throws ConnectionLostException {
			OnboardLED.write(false);
			Arduino0.write(button0.isChecked() || buttonAll.isChecked());
			Arduino1.write(button1.isChecked() || buttonAll.isChecked());
			Arduino2.write(button2.isChecked() || buttonAll.isChecked());
			Arduino3.write(button3.isChecked() || buttonAll.isChecked());
			Arduino4.write(button4.isChecked() || buttonAll.isChecked());
			Arduino5.write(button5.isChecked() || buttonAll.isChecked());
			Arduino6.write(button6.isChecked() || buttonAll.isChecked());
			Arduino7.write(button7.isChecked() || buttonAll.isChecked());
			Arduino8.write(button8.isChecked() || buttonAll.isChecked());
			Arduino9.write(button9.isChecked() || buttonAll.isChecked());
			Arduino10.write(button10.isChecked() || buttonAll.isChecked());
			Arduino11.write(button11.isChecked() || buttonAll.isChecked());
			Arduino12.write(button12.isChecked() || buttonAll.isChecked());
			Arduino13.write(button13.isChecked() || buttonAll.isChecked());
			
			try {
				V0= A0.getVoltage();
				V1= A1.getVoltage();
				V2= A2.getVoltage();
				V3= A3.getVoltage();
				V4= A4.getVoltage();
				V5= A5.getVoltage();
				V_in= Vin.getVoltage()*VinScale;
				updateText();
				
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
			}
		}
	}

	/**
	 * A method to create our IOIO thread.
	 * 
	 * @see ioio.lib.util.AbstractIOIOActivity#createIOIOThread()
	 */
	@Override
	protected IOIOLooper createIOIOLooper() {
		return new Looper();
	}
}